#ifndef _DEF_H_
#define _DEF_H_


#define GP2X_BUTTON_UP              (0)
#define GP2X_BUTTON_DOWN            (4)
#define GP2X_BUTTON_LEFT            (2)
#define GP2X_BUTTON_RIGHT           (6)
#define GP2X_BUTTON_UPLEFT          (1)
#define GP2X_BUTTON_UPRIGHT         (7)
#define GP2X_BUTTON_DOWNLEFT        (3)
#define GP2X_BUTTON_DOWNRIGHT       (5)
#define GP2X_BUTTON_CLICK           (18)
#define GP2X_BUTTON_A               (12)
#define GP2X_BUTTON_B               (13)
#define GP2X_BUTTON_Y               (14)
#define GP2X_BUTTON_X               (15)
#define GP2X_BUTTON_L               (10)
#define GP2X_BUTTON_R               (11)
#define GP2X_BUTTON_START           (8)
#define GP2X_BUTTON_SELECT          (9)
#define GP2X_BUTTON_VOLUP           (16)
#define GP2X_BUTTON_VOLDOWN         (17)

//~ #define INHIBIT(X) X
#define INHIBIT(X) /* X */

#define SCREEN_WIDTH          320
#define SCREEN_HEIGHT         240
#define SCREEN_BPP            16
#define SURFACE_FLAGS         SDL_SWSURFACE
#define MS_PER_FRAME          33
// Panel
#define LINE_HEIGHT           15
#define NB_VISIBLE_LINES      14
#define Y_LIST                17
#define Y_HEADER              3
#define Y_FOOTER              228
#define H_FOOTER              13
// Dialogs
#define DIALOG_BORDER         2
#define DIALOG_MARGIN         8
// Colors
#define COLOR_KEY             255,0,255
#define COLOR_TEXT_NORMAL     70,27,10
#define COLOR_TEXT_TITLE      233,229,227
#define COLOR_TEXT_DIR        75,70,164
#define COLOR_TEXT_SELECTED   255,0,0
#define COLOR_CURSOR_1        232,152,80
#define COLOR_CURSOR_2        232,201,173
#define COLOR_BG_1            255,255,255
#define COLOR_BG_2            232,228,224
#define COLOR_BORDER          102,85,74

#ifdef PLATFORM_DINGOO
// Keys for Dingoo
#define MYKEY_UP            GP2X_BUTTON_UP           // Up
#define MYKEY_RIGHT         GP2X_BUTTON_RIGHT        // Right
#define MYKEY_DOWN          GP2X_BUTTON_DOWN         // Down
#define MYKEY_LEFT          GP2X_BUTTON_LEFT         // Left
#define MYKEY_SYSTEM        GP2X_BUTTON_X       // Y
#define MYKEY_PAGEUP        GP2X_BUTTON_L     // L
#define MYKEY_PAGEDOWN      GP2X_BUTTON_R    // R
#define MYKEY_OPEN          GP2X_BUTTON_A        // A
#define MYKEY_PARENT        GP2X_BUTTON_B         // B
#define MYKEY_OPERATION     GP2X_BUTTON_Y        // X
#define MYKEY_SELECT        GP2X_BUTTON_SELECT       // SELECT
#define MYKEY_TRANSFER      GP2X_BUTTON_START       // START
#define PATH_DEFAULT        "/mnt/sd"
#define FILE_SYSTEM         "/dev/mtdblock/3"
#else
// Keys for PC keyboard
#define MYKEY_UP            SDLK_UP
#define MYKEY_RIGHT         SDLK_RIGHT
#define MYKEY_DOWN          SDLK_DOWN
#define MYKEY_LEFT          SDLK_LEFT
#define MYKEY_SYSTEM        SDLK_q
#define MYKEY_PAGEUP        SDLK_PAGEUP
#define MYKEY_PAGEDOWN      SDLK_PAGEDOWN
#define MYKEY_OPEN          SDLK_RETURN
#define MYKEY_PARENT        SDLK_BACKSPACE
#define MYKEY_OPERATION     SDLK_a
#define MYKEY_SELECT        SDLK_INSERT
#define MYKEY_TRANSFER      SDLK_w
#define PATH_DEFAULT        "/"
#define FILE_SYSTEM         "/dev/sda4"
#endif

#endif
